package vo

import "codeup.aliyun.com/6552e56cc3b2728a4557fc18/plugin/proto"

type OperaTp string

const (
	OperaTpAccept  OperaTp = "01"
	OperaTpReturn  OperaTp = "02"
	OperaTpNoOpera OperaTp = "03"
	OperaTpGet     OperaTp = "04"
	OperaTpDelete  OperaTp = "05"
	OperaTpExpire  OperaTp = "06"
)

var notifyOrderTextMap = map[OperaTp]string{
	OperaTpAccept:  "优惠券承兑 (用户消费)",
	OperaTpReturn:  "优惠券返还 (撤销或者退货 T+1)",
	OperaTpNoOpera: "优惠券无操作 (撤销或者退货不返还券的情况)",
	OperaTpGet:     "优惠券获取 (赠券成功时)",
	OperaTpDelete:  "优惠券删除 (删除券)",
	OperaTpExpire:  "优惠券过期 (过期实时通知)",
}

var notifyOrderStatusMap = map[OperaTp]proto.Status{
	OperaTpAccept:  proto.Status_WRITE_OFF,
	OperaTpReturn:  proto.Status_REFUND,
	OperaTpNoOpera: proto.Status_REVOKE,
	OperaTpGet:     proto.Status_SUCCESS,
	OperaTpDelete:  proto.Status_DELETE,
	OperaTpExpire:  proto.Status_OVERDUE,
}

func (o OperaTp) GetText() string {
	msg, ok := notifyOrderTextMap[o]
	if !ok {
		return ""
	}
	return msg
}

func (o OperaTp) GetOrderStatus() proto.Status {
	if o == "" {
		return proto.Status_INVALID
	}
	if resultStatus, ok := notifyOrderStatusMap[o]; ok {
		return resultStatus
	}
	return proto.Status_FAIL
}
